]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - etc/rc.subr
This commit was generated by cvs2svn to compensate for changes in r163820,
[FreeBSD/FreeBSD.git] / etc / rc.subr
1 # $NetBSD: rc.subr,v 1.66 2006/04/01 10:05:50 he Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 # 3. All advertising materials mentioning features or use of this software
19 #    must display the following acknowledgement:
20 #        This product includes software developed by the NetBSD
21 #        Foundation, Inc. and its contributors.
22 # 4. Neither the name of The NetBSD Foundation nor the names of its
23 #    contributors may be used to endorse or promote products derived
24 #    from this software without specific prior written permission.
25 #
26 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
27 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
28 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
29 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
30 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
31 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
32 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
33 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
34 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
35 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
36 # POSSIBILITY OF SUCH DAMAGE.
37 #
38 # rc.subr
39 #       functions used by various rc scripts
40 #
41
42 : ${rcvar_manpage:='rc.conf(5)'}
43
44 #
45 #       Operating System dependent/independent variables
46 #
47
48 if [ -z "${_rc_subr_loaded}" ]; then
49
50 _rc_subr_loaded="YES"
51
52 SYSCTL="/sbin/sysctl"
53 SYSCTL_N="${SYSCTL} -n"
54 CMD_OSTYPE="${SYSCTL_N} kern.ostype"
55 OSTYPE=`${CMD_OSTYPE}`
56 ID="/usr/bin/id"
57 IDCMD="if [ -x $ID ]; then $ID -un; fi"
58 PS="/bin/ps -ww"
59 JID=`$PS -p $$ -o jid=`
60
61 case ${OSTYPE} in
62 FreeBSD)
63         SYSCTL_W="${SYSCTL}"
64         ;;
65 NetBSD)
66         SYSCTL_W="${SYSCTL} -w"
67         ;;
68 esac
69
70 #
71 #       functions
72 #       ---------
73
74 #
75 # set_rcvar base_var
76 #       Set the variable name enabling a specific service.
77 #       FreeBSD uses ${service}_enable, while NetBSD uses
78 #       just the name of the service. For example:
79 #       FreeBSD: sendmail_enable="YES"
80 #       NetBSD : sendmail="YES"
81 #       $1 - if $name is not the base to work of off, specify
82 #            a different one
83 #
84 set_rcvar()
85 {
86         if [ -z "$1" ]; then
87                 base_var=${name}
88         else
89                 base_var="$1"
90         fi
91
92         case ${OSTYPE} in
93         FreeBSD)
94                 echo ${base_var}_enable
95                 ;;
96         NetBSD)
97                 echo ${base_var}
98                 ;;
99         *)
100                 echo 'XXX'
101                 ;;
102         esac
103 }
104
105 #
106 # force_depend script
107 #       Force a service to start. Intended for use by services
108 #       to resolve dependency issues. It is assumed the caller
109 #       has check to make sure this call is necessary
110 #       $1 - filename of script, in /etc/rc.d, to run
111 #
112 force_depend()
113 {
114         _depend="$1"
115
116         info "${name} depends on ${_depend}, which will be forced to start."
117         if ! /etc/rc.d/${_depend} forcestart; then
118                 warn "Unable to force ${_depend}. It may already be running."
119                 return 1
120         fi
121         return 0
122 }
123
124 #
125 # checkyesno var
126 #       Test $1 variable, and warn if not set to YES or NO.
127 #       Return 0 if it's "yes" (et al), nonzero otherwise.
128 #
129 checkyesno()
130 {
131         eval _value=\$${1}
132         debug "checkyesno: $1 is set to $_value."
133         case $_value in
134
135                 #       "yes", "true", "on", or "1"
136         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
137                 return 0
138                 ;;
139
140                 #       "no", "false", "off", or "0"
141         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
142                 return 1
143                 ;;
144         *)
145                 warn "\$${1} is not set properly - see ${rcvar_manpage}."
146                 return 1
147                 ;;
148         esac
149 }
150
151 #
152 # reverse_list list
153 #       print the list in reverse order
154 #
155 reverse_list()
156 {
157         _revlist=
158         for _revfile; do
159                 _revlist="$_revfile $_revlist"
160         done
161         echo $_revlist
162 }
163
164 #
165 # mount_critical_filesystems type
166 #       Go through the list of critical filesystems as provided in
167 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
168 #       each one to see if it is mounted, and if it is not, mounting it.
169 #
170 mount_critical_filesystems()
171 {
172         eval _fslist=\$critical_filesystems_${1}
173         for _fs in $_fslist; do
174                 mount | (
175                         _ismounted=false
176                         while read what _on on _type type; do
177                                 if [ $on = $_fs ]; then
178                                         _ismounted=true
179                                 fi
180                         done
181                         if $_ismounted; then
182                                 :
183                         else
184                                 mount $_fs >/dev/null 2>&1
185                         fi
186                 )
187         done
188 }
189
190 #
191 # check_pidfile pidfile procname [interpreter]
192 #       Parses the first line of pidfile for a PID, and ensures
193 #       that the process is running and matches procname.
194 #       Prints the matching PID upon success, nothing otherwise.
195 #       interpreter is optional; see _find_processes() for details.
196 #
197 check_pidfile()
198 {
199         _pidfile=$1
200         _procname=$2
201         _interpreter=$3
202         if [ -z "$_pidfile" -o -z "$_procname" ]; then
203                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
204         fi
205         if [ ! -f $_pidfile ]; then
206                 debug "pid file ($_pidfile): not readable."
207                 return
208         fi
209         read _pid _junk < $_pidfile
210         if [ -z "$_pid" ]; then
211                 debug "pid file ($_pidfile): no pid in file."
212                 return
213         fi
214         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
215 }
216
217 #
218 # check_process procname [interpreter]
219 #       Ensures that a process (or processes) named procname is running.
220 #       Prints a list of matching PIDs.
221 #       interpreter is optional; see _find_processes() for details.
222 #
223 check_process()
224 {
225         _procname=$1
226         _interpreter=$2
227         if [ -z "$_procname" ]; then
228                 err 3 'USAGE: check_process procname [interpreter]'
229         fi
230         _find_processes $_procname ${_interpreter:-.} '-ax'
231 }
232
233 #
234 # _find_processes procname interpreter psargs
235 #       Search for procname in the output of ps generated by psargs.
236 #       Prints the PIDs of any matching processes, space separated.
237 #
238 #       If interpreter == ".", check the following variations of procname
239 #       against the first word of each command:
240 #               procname
241 #               `basename procname`
242 #               `basename procname` + ":"
243 #               "(" + `basename procname` + ")"
244 #               "[" + `basename procname` + "]"
245 #
246 #       If interpreter != ".", read the first line of procname, remove the
247 #       leading #!, normalise whitespace, append procname, and attempt to
248 #       match that against each command, either as is, or with extra words
249 #       at the end.  As an alternative, to deal with interpreted daemons
250 #       using perl, the basename of the interpreter plus a colon is also
251 #       tried as the prefix to procname.
252 #
253 _find_processes()
254 {
255         if [ $# -ne 3 ]; then
256                 err 3 'USAGE: _find_processes procname interpreter psargs'
257         fi
258         _procname=$1
259         _interpreter=$2
260         _psargs=$3
261
262         _pref=
263         if [ $_interpreter != "." ]; then       # an interpreted script
264                 read _interp < $_procname       # read interpreter name
265                 _interp=${_interp#\#!}          # strip #!
266                 set -- $_interp
267                 if [ $_interpreter != $1 ]; then
268                         warn "\$command_interpreter $_interpreter != $1"
269                 fi
270                 _interp="$* $_procname"         # cleanup spaces, add _procname
271                 _interpbn=${1##*/}
272                 _fp_args='_argv'
273                 _fp_match='case "$_argv" in
274                     ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
275         else                                    # a normal daemon
276                 _procnamebn=${_procname##*/}
277                 _fp_args='_arg0 _argv'
278                 _fp_match='case "$_arg0" in
279                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
280         fi
281
282         _proccheck="\
283                 $PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
284                 while read _npid _jid '"$_fp_args"'; do
285                         '"$_fp_match"'
286                                 if [ "$JID" -eq "$_jid" ];
287                                 then echo -n "$_pref$_npid";
288                                 _pref=" ";
289                                 fi
290                                 ;;
291                         esac
292                 done'
293
294 #       debug "in _find_processes: proccheck is ($_proccheck)."
295         eval $_proccheck
296 }
297
298 #
299 # wait_for_pids pid [pid ...]
300 #       spins until none of the pids exist
301 #
302 wait_for_pids()
303 {
304         _list="$@"
305         if [ -z "$_list" ]; then
306                 return
307         fi
308         _prefix=
309         while true; do
310                 _nlist="";
311                 for _j in $_list; do
312                         if kill -0 $_j 2>/dev/null; then
313                                 _nlist="${_nlist}${_nlist:+ }$_j"
314                         fi
315                 done
316                 if [ -z "$_nlist" ]; then
317                         break
318                 fi
319                 _list=$_nlist
320                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
321                 _prefix=", "
322                 sleep 2
323         done
324         if [ -n "$_prefix" ]; then
325                 echo "."
326         fi
327 }
328
329 #
330 # run_rc_command argument
331 #       Search for argument in the list of supported commands, which is:
332 #               "start stop restart rcvar status poll ${extra_commands}"
333 #       If there's a match, run ${argument}_cmd or the default method
334 #       (see below).
335 #
336 #       If argument has a given prefix, then change the operation as follows:
337 #               Prefix  Operation
338 #               ------  ---------
339 #               fast    Skip the pid check, and set rc_fast=yes
340 #               force   Set ${rcvar} to YES, and set rc_force=yes
341 #               one     Set ${rcvar} to YES
342 #
343 #       The following globals are used:
344 #
345 #       Name            Needed  Purpose
346 #       ----            ------  -------
347 #       name            y       Name of script.
348 #
349 #       command         n       Full path to command.
350 #                               Not needed if ${rc_arg}_cmd is set for
351 #                               each keyword.
352 #
353 #       command_args    n       Optional args/shell directives for command.
354 #
355 #       command_interpreter n   If not empty, command is interpreted, so
356 #                               call check_{pidfile,process}() appropriately.
357 #
358 #       extra_commands  n       List of extra commands supported.
359 #
360 #       pidfile         n       If set, use check_pidfile $pidfile $command,
361 #                               otherwise use check_process $command.
362 #                               In either case, only check if $command is set.
363 #
364 #       procname        n       Process name to check for instead of $command.
365 #
366 #       rcvar           n       This is checked with checkyesno to determine
367 #                               if the action should be run.
368 #
369 #       ${name}_program n       Full path to command.
370 #                               Meant to be used in /etc/rc.conf to override
371 #                               ${command}.
372 #
373 #       ${name}_chroot  n       Directory to chroot to before running ${command}
374 #                               Requires /usr to be mounted.
375 #
376 #       ${name}_chdir   n       Directory to cd to before running ${command}
377 #                               (if not using ${name}_chroot).
378 #
379 #       ${name}_flags   n       Arguments to call ${command} with.
380 #                               NOTE:   $flags from the parent environment
381 #                                       can be used to override this.
382 #
383 #       ${name}_nice    n       Nice level to run ${command} at.
384 #
385 #       ${name}_user    n       User to run ${command} as, using su(1) if not
386 #                               using ${name}_chroot.
387 #                               Requires /usr to be mounted.
388 #
389 #       ${name}_group   n       Group to run chrooted ${command} as.
390 #                               Requires /usr to be mounted.
391 #
392 #       ${name}_groups  n       Comma separated list of supplementary groups
393 #                               to run the chrooted ${command} with.
394 #                               Requires /usr to be mounted.
395 #
396 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
397 #                               Otherwise, use default command (see below)
398 #
399 #       ${rc_arg}_precmd n      If set, run just before performing the
400 #                               ${rc_arg}_cmd method in the default
401 #                               operation (i.e, after checking for required
402 #                               bits and process (non)existence).
403 #                               If this completes with a non-zero exit code,
404 #                               don't run ${rc_arg}_cmd.
405 #
406 #       ${rc_arg}_postcmd n     If set, run just after performing the
407 #                               ${rc_arg}_cmd method, if that method
408 #                               returned a zero exit code.
409 #
410 #       required_dirs   n       If set, check for the existence of the given
411 #                               directories before running the default
412 #                               (re)start command.
413 #
414 #       required_files  n       If set, check for the readability of the given
415 #                               files before running the default (re)start
416 #                               command.
417 #
418 #       required_vars   n       If set, perform checkyesno on each of the
419 #                               listed variables before running the default
420 #                               (re)start command.
421 #
422 #       Default behaviour for a given argument, if no override method is
423 #       provided:
424 #
425 #       Argument        Default behaviour
426 #       --------        -----------------
427 #       start           if !running && checkyesno ${rcvar}
428 #                               ${command}
429 #
430 #       stop            if ${pidfile}
431 #                               rc_pid=$(check_pidfile $pidfile $command)
432 #                       else
433 #                               rc_pid=$(check_process $command)
434 #                       kill $sig_stop $rc_pid
435 #                       wait_for_pids $rc_pid
436 #                       ($sig_stop defaults to TERM.)
437 #
438 #       reload          Similar to stop, except use $sig_reload instead,
439 #                       and doesn't wait_for_pids.
440 #                       $sig_reload defaults to HUP.
441 #                       Note that `reload' isn't provided by default,
442 #                       it should be enabled via $extra_commands.
443 #
444 #       restart         Run `stop' then `start'.
445 #
446 #       status          Show if ${command} is running, etc.
447 #
448 #       poll            Wait for ${command} to exit.
449 #
450 #       rcvar           Display what rc.conf variable is used (if any).
451 #
452 #       Variables available to methods, and after run_rc_command() has
453 #       completed:
454 #
455 #       Variable        Purpose
456 #       --------        -------
457 #       rc_arg          Argument to command, after fast/force/one processing
458 #                       performed
459 #
460 #       rc_flags        Flags to start the default command with.
461 #                       Defaults to ${name}_flags, unless overridden
462 #                       by $flags from the environment.
463 #                       This variable may be changed by the precmd method.
464 #
465 #       rc_pid          PID of command (if appropriate)
466 #
467 #       rc_fast         Not empty if "fast" was provided (q.v.)
468 #
469 #       rc_force        Not empty if "force" was provided (q.v.)
470 #
471 #
472 run_rc_command()
473 {
474         _return=0
475         rc_arg=$1
476         if [ -z "$name" ]; then
477                 err 3 'run_rc_command: $name is not set.'
478         fi
479
480         # Don't repeat the first argument when passing additional command-
481         # line arguments to the command subroutines.
482         #
483         shift 1
484         rc_extra_args="$*"
485
486         _rc_prefix=
487         case "$rc_arg" in
488         fast*)                          # "fast" prefix; don't check pid
489                 rc_arg=${rc_arg#fast}
490                 rc_fast=yes
491                 ;;
492         force*)                         # "force prefix; always run
493                 rc_force=yes
494                 _rc_prefix=force
495                 rc_arg=${rc_arg#${_rc_prefix}}
496                 if [ -n "${rcvar}" ]; then
497                         eval ${rcvar}=YES
498                 fi
499                 ;;
500         one*)                           # "one" prefix; set ${rcvar}=yes
501                 _rc_prefix=one
502                 rc_arg=${rc_arg#${_rc_prefix}}
503                 if [ -n "${rcvar}" ]; then
504                         eval ${rcvar}=YES
505                 fi
506                 ;;
507         esac
508
509         eval _override_command=\$${name}_program
510         command=${command:+${_override_command:-$command}}
511
512         _keywords="start stop restart rcvar $extra_commands"
513         rc_pid=
514         _pidcmd=
515         _procname=${procname:-${command}}
516
517                                         # setup pid check command
518         if [ -n "$_procname" ]; then
519                 if [ -n "$pidfile" ]; then
520                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
521                 else
522                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
523                 fi
524                 if [ -n "$_pidcmd" ]; then
525                         _keywords="${_keywords} status poll"
526                 fi
527         fi
528
529         if [ -z "$rc_arg" ]; then
530                 rc_usage $_keywords
531         fi
532
533         if [ -n "$flags" ]; then        # allow override from environment
534                 rc_flags=$flags
535         else
536                 eval rc_flags=\$${name}_flags
537         fi
538         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
539             _nice=\$${name}_nice        _user=\$${name}_user \
540             _group=\$${name}_group      _groups=\$${name}_groups
541
542         if [ -n "$_user" ]; then        # unset $_user if running as that user
543                 if [ "$_user" = "$(eval $IDCMD)" ]; then
544                         unset _user
545                 fi
546         fi
547
548                                         # if ${rcvar} is set, and $1 is not
549                                         # "rcvar", then run
550                                         #       checkyesno ${rcvar}
551                                         # and return if that failed
552                                         #
553         if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
554                 if ! checkyesno ${rcvar}; then
555                         return 0
556                 fi
557         fi
558
559         eval $_pidcmd                   # determine the pid if necessary
560
561         for _elem in $_keywords; do
562                 if [ "$_elem" != "$rc_arg" ]; then
563                         continue
564                 fi
565
566                                         # if there's a custom ${XXX_cmd},
567                                         # run that instead of the default
568                                         #
569                 eval _cmd=\$${rc_arg}_cmd _precmd=\$${rc_arg}_precmd \
570                     _postcmd=\$${rc_arg}_postcmd
571                 if [ -n "$_cmd" ]; then
572                                         # if the precmd failed and force
573                                         # isn't set, exit
574                                         #
575                         if [ -n "$_precmd" ]; then
576                                 debug "run_rc_command: evaluating ${_precmd}()."
577                                 eval $_precmd $rc_extra_args
578                                 _return=$?
579                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
580                                     return 1
581                         fi
582
583                         if [ -n "$_cmd" ]; then
584                                 debug "run_rc_command: evaluating ${_cmd}()."
585                                 eval $_cmd $rc_extra_args
586                                 _return=$?
587                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
588                                     return 1
589                         fi
590
591                         if [ -n "$_postcmd" ]; then
592                                 debug "run_rc_command: evaluating ${_postcmd}()."
593                                  eval $_postcmd $rc_extra_args
594                                 _return=$?
595                         fi
596                         return $_return
597                 fi
598
599                 case "$rc_arg" in       # default operations...
600
601                 status)
602                         if [ -n "$rc_pid" ]; then
603                                 echo "${name} is running as pid $rc_pid."
604                         else
605                                 echo "${name} is not running."
606                                 return 1
607                         fi
608                         ;;
609
610                 start)
611                         if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
612                                 echo 1>&2 "${name} already running? (pid=$rc_pid)."
613                                 return 1
614                         fi
615
616                         if [ ! -x ${_chroot}${command} ]; then
617                                 warn "run_rc_command: cannot run $command"
618                                 return 1
619                         fi
620
621                                         # check for required variables,
622                                         # directories, and files
623                                         #
624                         for _f in $required_vars; do
625                                 if ! checkyesno $_f; then
626                                         warn "\$${_f} is not enabled."
627                                         if [ -z "$rc_force" ]; then
628                                                 return 1
629                                         fi
630                                 fi
631                         done
632                         for _f in $required_dirs; do
633                                 if [ ! -d "${_f}/." ]; then
634                                         warn "${_f} is not a directory."
635                                         if [ -z "$rc_force" ]; then
636                                                 return 1
637                                         fi
638                                 fi
639                         done
640                         for _f in $required_files; do
641                                 if [ ! -r "${_f}" ]; then
642                                         warn "${_f} is not readable."
643                                         if [ -z "$rc_force" ]; then
644                                                 return 1
645                                         fi
646                                 fi
647                         done
648
649                                         # if the precmd failed and force
650                                         # isn't set, exit
651                                         #
652                         if [ -n "${_precmd}" ]; then
653                                 debug "run_rc_command: evaluating ${_precmd}()."
654                                 eval $_precmd
655                                 _return=$?
656                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
657                                     return 1
658                         fi
659
660                                         # setup the full command to run
661                                         #
662                         echo "Starting ${name}."
663                         if [ -n "$_chroot" ]; then
664                                 _doit="\
665 ${_nice:+nice -n $_nice }\
666 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
667 $_chroot $command $rc_flags $command_args"
668                         else
669                                 _doit="\
670 ${_chdir:+cd $_chdir && }\
671 $command $rc_flags $command_args"
672                                 if [ -n "$_user" ]; then
673                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
674                                 fi
675                                 if [ -n "$_nice" ]; then
676                                         if [ -z "$_user" ]; then
677                                                 _doit="sh -c \"$_doit\""
678                                         fi      
679                                         _doit="nice -n $_nice $_doit"
680                                 fi
681                         fi
682
683                                         # run the full command;
684                                         # if the cmd failed and force
685                                         # isn't set, exit
686                                         #
687                         debug "run_rc_command: _doit: $_doit"
688                         eval $_doit
689                         _return=$?
690                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
691
692                                         # finally, run postcmd
693                                         #
694                         if [ -n "${_postcmd}" ]; then
695                                 debug "run_rc_command: evaluating ${_postcmd}()."
696                                 eval $_postcmd
697                         fi
698                         ;;
699
700                 stop)
701                         if [ -z "$rc_pid" ]; then
702                                 [ -n "$rc_fast" ] && return 0
703                                 if [ -n "$pidfile" ]; then
704                                         echo 1>&2 \
705                                     "${name} not running? (check $pidfile)."
706                                 else
707                                         echo 1>&2 "${name} not running?"
708                                 fi
709                                 return 1
710                         fi
711
712                                         # if the precmd failed and force
713                                         # isn't set, exit
714                                         #
715                         if [ -n "$_precmd" ]; then
716                                 eval $_precmd
717                                 _return=$?
718                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
719                                     return 1
720                         fi
721
722                                         # send the signal to stop
723                                         #
724                         echo "Stopping ${name}."
725                         _doit="kill -${sig_stop:-TERM} $rc_pid"
726                         if [ -n "$_user" ]; then
727                                 _doit="su -m $_user -c 'sh -c \"$_doit\"'"
728                         fi
729
730                                         # if the stop cmd failed and force
731                                         # isn't set, exit
732                                         #
733                         eval $_doit
734                         _return=$?
735                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
736
737                                         # wait for the command to exit,
738                                         # and run postcmd.
739                         wait_for_pids $rc_pid
740                         if [ -n "$_postcmd" ]; then
741                                 eval $_postcmd
742                                 _return=$?
743                         fi
744                         ;;
745
746                 reload)
747                         if [ -z "$rc_pid" ]; then
748                                 if [ -n "$pidfile" ]; then
749                                         echo 1>&2 \
750                                     "${name} not running? (check $pidfile)."
751                                 else
752                                         echo 1>&2 "${name} not running?"
753                                 fi
754                                 return 1
755                         fi
756                         echo "Reloading ${name} config files."
757                         if [ -n "$_precmd" ]; then
758                                 eval $_precmd
759                                 _return=$?
760                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
761                                     return 1
762                         fi
763                         _doit="kill -${sig_reload:-HUP} $rc_pid"
764                         if [ -n "$_user" ]; then
765                                 _doit="su -m $_user -c 'sh -c \"$_doit\"'"
766                         fi
767                         eval $_doit
768                         _return=$?
769                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
770                         if [ -n "$_postcmd" ]; then
771                                 eval $_postcmd
772                                 _return=$?
773                         fi
774                         ;;
775
776                 restart)
777                         if [ -n "$_precmd" ]; then
778                                 eval $_precmd $rc_extra_args
779                                 _return=$?
780                                 [ $_return -ne 0 ] && [ -z "$rc_force" ] &&
781                                     return 1
782                         fi
783                                         # prevent restart being called more
784                                         # than once by any given script
785                                         #
786                         if ${_rc_restart_done:-false}; then
787                                 return 0
788                         fi
789                         _rc_restart_done=true
790
791                         # run stop in a subshell to keep variables for start
792                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
793                         run_rc_command ${_rc_prefix}start $rc_extra_args
794
795                         if [ -n "$_postcmd" ]; then
796                                 eval $_postcmd $rc_extra_args
797                                 _return=$?
798                         fi
799                         ;;
800
801                 poll)
802                         if [ -n "$rc_pid" ]; then
803                                 wait_for_pids $rc_pid
804                         fi
805                         ;;
806
807                 rcvar)
808                         echo "# $name"
809                         if [ -n "$rcvar" ]; then
810                                 if checkyesno ${rcvar}; then
811                                         echo "\$${rcvar}=YES"
812                                 else
813                                         echo "\$${rcvar}=NO"
814                                 fi
815                         fi
816                         ;;
817
818                 *)
819                         rc_usage $_keywords
820                         ;;
821
822                 esac
823                 return $_return
824         done
825
826         echo 1>&2 "$0: unknown directive '$rc_arg'."
827         rc_usage $_keywords
828         # not reached
829 }
830
831 #
832 # run_rc_script file arg
833 #       Start the script `file' with `arg', and correctly handle the
834 #       return value from the script.  If `file' ends with `.sh', it's
835 #       sourced into the current environment.  If `file' appears to be
836 #       a backup or scratch file, ignore it.  Otherwise if it's
837 #       executable run as a child process.
838 #
839 run_rc_script()
840 {
841         _file=$1
842         _arg=$2
843         if [ -z "$_file" -o -z "$_arg" ]; then
844                 err 3 'USAGE: run_rc_script file arg'
845         fi
846
847         unset   name command command_args command_interpreter \
848                 extra_commands pidfile procname \
849                 rcvar required_dirs required_files required_vars
850         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
851
852         case "$_file" in
853         /etc/rc.d/*.sh)                 # run in current shell
854                 set $_arg; . $_file
855                 ;;
856         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
857                 warn "Ignoring scratch file $_file"
858                 ;;
859         *)                              # run in subshell
860                 if [ -x $_file ]; then
861                         if [ -n "$rc_fast_and_loose" ]; then
862                                 set $_arg; . $_file
863                         else
864                                 ( trap "echo Script $_file interrupted; kill -QUIT $$" 3
865                                   trap "echo Script $_file interrupted; exit 1" 2
866                                   set $_arg; . $_file )
867                         fi
868                 fi
869                 ;;
870         esac
871 }
872
873 #
874 # load_rc_config name
875 #       Source in the configuration file for a given name.
876 #
877 load_rc_config()
878 {
879         _name=$1
880         if [ -z "$_name" ]; then
881                 err 3 'USAGE: load_rc_config name'
882         fi
883
884         if ${_rc_conf_loaded:-false}; then
885                 :
886         else
887                 if [ -r /etc/defaults/rc.conf ]; then
888                         debug "Sourcing /etc/defaults/rc.conf"
889                         . /etc/defaults/rc.conf
890                         source_rc_confs
891                 elif [ -r /etc/rc.conf ]; then
892                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
893                         . /etc/rc.conf
894                 fi
895                 _rc_conf_loaded=true
896         fi
897         if [ -f /etc/rc.conf.d/"$_name" ]; then
898                 debug "Sourcing /etc/rc.conf.d/${_name}"
899                 . /etc/rc.conf.d/"$_name"
900         fi
901
902         # XXX - Deprecated variable name support
903         #
904         case ${OSTYPE} in
905         FreeBSD)
906                 [ -n "$portmap_enable" ] && rpcbind_enable="$portmap_enable"
907                 [ -n "$portmap_program" ] && rpcbind_program="$portmap_program"
908                 [ -n "$portmap_flags" ] && rpcbind_flags="$portmap_flags"
909                 [ -n "$single_mountd_enable" ] && mountd_enable="$single_mountd_enable"
910                 [ -n "$xntpd_enable" ] && ntpd_enable="$xntpd_enable"
911                 [ -n "$xntpd_program" ] && ntpd_program="$xntpd_program"
912                 [ -n "$xntpd_flags" ] && ntpd_flags="$xntpd_flags"
913                 [ -n "$dhcp_program" ] && dhclient_program="$dhcp_program"
914                 [ -n "$dhcp_flags" ] && dhclient_flags="$dhcp_flags"
915                 ;;
916         esac
917 }
918   
919 #
920 # load_rc_config_var name var
921 #       Read the rc.conf(5) var for name and set in the
922 #       current shell, using load_rc_config in a subshell to prevent
923 #       unwanted side effects from other variable assignments.
924 #
925 load_rc_config_var()
926 {
927         if [ $# -ne 2 ]; then
928                 err 3 'USAGE: load_rc_config_var name var'
929         fi
930         eval $(eval '(
931                 load_rc_config '$1' >/dev/null;
932                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
933                         echo '$2'=\'\''${'$2'}\'\'';
934                 fi
935         )' )
936 }
937
938 #
939 # rc_usage commands
940 #       Print a usage string for $0, with `commands' being a list of
941 #       valid commands.
942 #
943 rc_usage()
944 {
945         echo -n 1>&2 "Usage: $0 [fast|force|one]("
946
947         _sep=
948         for _elem; do
949                 echo -n 1>&2 "$_sep$_elem"
950                 _sep="|"
951         done
952         echo 1>&2 ")"
953         exit 1
954 }
955
956 #
957 # err exitval message
958 #       Display message to stderr and log to the syslog, and exit with exitval.
959 #
960 err()
961 {
962         exitval=$1
963         shift
964
965         if [ -x /usr/bin/logger ]; then
966                 logger "$0: ERROR: $*"
967         fi
968         echo 1>&2 "$0: ERROR: $*"
969         exit $exitval
970 }
971
972 #
973 # warn message
974 #       Display message to stderr and log to the syslog.
975 #
976 warn()
977 {
978         if [ -x /usr/bin/logger ]; then
979                 logger "$0: WARNING: $*"
980         fi
981         echo 1>&2 "$0: WARNING: $*"
982 }
983
984 #
985 # info message
986 #       Display informational message to stdout and log to syslog.
987 #
988 info()
989 {
990         case ${rc_info} in
991         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
992                 if [ -x /usr/bin/logger ]; then
993                         logger "$0: INFO: $*"
994                 fi
995                 echo "$0: INFO: $*"
996                 ;;
997         esac
998 }
999
1000 #
1001 # debug message
1002 #       If debugging is enabled in rc.conf output message to stderr.
1003 #       BEWARE that you don't call any subroutine that itself calls this
1004 #       function.
1005 #
1006 debug()
1007 {
1008         case ${rc_debug} in
1009         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1010                 if [ -x /usr/bin/logger ]; then
1011                         logger "$0: DEBUG: $*"
1012                 fi
1013                 echo 1>&2 "$0: DEBUG: $*"
1014                 ;;
1015         esac
1016 }
1017
1018 #
1019 # backup_file action file cur backup
1020 #       Make a backup copy of `file' into `cur', and save the previous
1021 #       version of `cur' as `backup' or use rcs for archiving.
1022 #
1023 #       This routine checks the value of the backup_uses_rcs variable,
1024 #       which can be either YES or NO.
1025 #
1026 #       The `action' keyword can be one of the following:
1027 #
1028 #       add             `file' is now being backed up (and is possibly
1029 #                       being reentered into the backups system).  `cur'
1030 #                       is created and RCS files, if necessary, are
1031 #                       created as well.
1032 #
1033 #       update          `file' has changed and needs to be backed up.
1034 #                       If `cur' exists, it is copied to to `back' or
1035 #                       checked into RCS (if the repository file is old),
1036 #                       and then `file' is copied to `cur'.  Another RCS
1037 #                       check in done here if RCS is being used.
1038 #
1039 #       remove          `file' is no longer being tracked by the backups
1040 #                       system.  If RCS is not being used, `cur' is moved
1041 #                       to `back', otherwise an empty file is checked in,
1042 #                       and then `cur' is removed.
1043 #
1044 #
1045 backup_file()
1046 {
1047         _action=$1
1048         _file=$2
1049         _cur=$3
1050         _back=$4
1051
1052         if checkyesno backup_uses_rcs; then
1053                 _msg0="backup archive"
1054                 _msg1="update"
1055
1056                 # ensure that history file is not locked
1057                 if [ -f $_cur,v ]; then
1058                         rcs -q -u -U -M $_cur
1059                 fi
1060
1061                 # ensure after switching to rcs that the
1062                 # current backup is not lost
1063                 if [ -f $_cur ]; then
1064                         # no archive, or current newer than archive
1065                         if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1066                                 ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1067                                 rcs -q -kb -U $_cur
1068                                 co -q -f -u $_cur
1069                         fi
1070                 fi
1071
1072                 case $_action in
1073                 add|update)
1074                         cp -p $_file $_cur
1075                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1076                         rcs -q -kb -U $_cur
1077                         co -q -f -u $_cur
1078                         chown root:wheel $_cur $_cur,v
1079                         ;;
1080                 remove)
1081                         cp /dev/null $_cur
1082                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1083                         rcs -q -kb -U $_cur
1084                         chown root:wheel $_cur $_cur,v
1085                         rm $_cur
1086                         ;;
1087                 esac
1088         else
1089                 case $_action in
1090                 add|update)
1091                         if [ -f $_cur ]; then
1092                                 cp -p $_cur $_back
1093                         fi
1094                         cp -p $_file $_cur
1095                         chown root:wheel $_cur
1096                         ;;
1097                 remove)
1098                         mv -f $_cur $_back
1099                         ;;
1100                 esac
1101         fi
1102 }
1103
1104 # make_symlink src link
1105 #       Make a symbolic link 'link' to src from basedir. If the
1106 #       directory in which link is to be created does not exist
1107 #       a warning will be displayed and an error will be returned.
1108 #       Returns 0 on sucess, 1 otherwise.
1109 #
1110 make_symlink()
1111 {
1112         local src link linkdir _me
1113         src="$1"
1114         link="$2"
1115         linkdir="`dirname $link`"
1116         _me="make_symlink()"
1117
1118         if [ -z "$src" -o -z "$link" ]; then
1119                 warn "$_me: requires two arguments."
1120                 return 1
1121         fi
1122         if [ ! -d "$linkdir" ]; then
1123                 warn "$_me: the directory $linkdir does not exist."
1124                 return 1
1125         fi
1126         if ! ln -sf $src $link; then
1127                 warn "$_me: unable to make a symbolic link from $link to $src"
1128                 return 1
1129         fi
1130         return 0
1131 }
1132
1133 # devfs_rulesets_from_file file
1134 #       Reads a set of devfs commands from file, and creates
1135 #       the specified rulesets with their rules. Returns non-zero
1136 #       if there was an error.
1137 #
1138 devfs_rulesets_from_file()
1139 {
1140         local file _err _me
1141         file="$1"
1142         _me="devfs_rulesets_from_file"
1143         _err=0
1144
1145         if [ -z "$file" ]; then
1146                 warn "$_me: you must specify a file"
1147                 return 1
1148         fi
1149         if [ ! -e "$file" ]; then
1150                 debug "$_me: no such file ($file)"
1151                 return 0
1152         fi
1153         debug "reading rulesets from file ($file)"
1154         { while read line
1155         do
1156                 case $line in
1157                 \#*)
1158                         continue
1159                         ;;
1160                 \[*\]*)
1161                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1162                         if [ -z "$rulenum" ]; then
1163                                 warn "$_me: cannot extract rule number ($line)"
1164                                 _err=1
1165                                 break
1166                         fi
1167                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1168                         if [ -z "$rulename" ]; then
1169                                 warn "$_me: cannot extract rule name ($line)"
1170                                 _err=1
1171                                 break;
1172                         fi
1173                         eval $rulename=\$rulenum
1174                         debug "found ruleset: $rulename=$rulenum"
1175                         if ! /sbin/devfs rule -s $rulenum delset; then
1176                                 _err=1
1177                                 break
1178                         fi
1179                         ;;
1180                 *)
1181                         rulecmd="${line%%"\#*"}"
1182                         # evaluate the command incase it includes
1183                         # other rules
1184                         if [ -n "$rulecmd" ]; then
1185                                 debug "adding rule ($rulecmd)"
1186                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1187                                 then
1188                                         _err=1
1189                                         break
1190                                 fi
1191                         fi
1192                         ;;
1193                 esac
1194                 if [ $_err -ne 0 ]; then
1195                         debug "error in $_me"
1196                         break
1197                 fi
1198         done } < $file
1199         return $_err
1200 }
1201
1202 # devfs_init_rulesets
1203 #       Initializes rulesets from configuration files. Returns
1204 #       non-zero if there was an error.
1205 #
1206 devfs_init_rulesets()
1207 {
1208         local file _me
1209         _me="devfs_init_rulesets"
1210
1211         # Go through this only once
1212         if [ -n "$devfs_rulesets_init" ]; then
1213                 debug "$_me: devfs rulesets already initialized"
1214                 return
1215         fi
1216         for file in $devfs_rulesets; do
1217                 devfs_rulesets_from_file $file || return 1
1218         done
1219         devfs_rulesets_init=1
1220         debug "$_me: devfs rulesets initialized"
1221         return 0
1222 }
1223
1224 # devfs_set_ruleset ruleset [dir]
1225 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1226 #       must be a ruleset name as specified in devfs.rules(5) file.
1227 #       Returns non-zero if it could not set it successfully.
1228 #
1229 devfs_set_ruleset()
1230 {
1231         local devdir rs _me
1232         [ -n "$1" ] && eval rs=\$$1 || rs=
1233         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1234         _me="devfs_set_ruleset"
1235
1236         if [ -z "$rs" ]; then
1237                 warn "$_me: you must specify a ruleset number"
1238                 return 1
1239         fi
1240         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1241         if ! /sbin/devfs $devdir ruleset $rs; then
1242                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1243                 return 1
1244         fi
1245         return 0
1246 }
1247
1248 # devfs_apply_ruleset ruleset [dir]
1249 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1250 #       The ruleset argument must be a ruleset name as specified
1251 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1252 #       if it could not apply the ruleset.
1253 #
1254 devfs_apply_ruleset()
1255 {
1256         local devdir rs _me
1257         [ -n "$1" ] && eval rs=\$$1 || rs=
1258         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1259         _me="devfs_apply_ruleset"
1260
1261         if [ -z "$rs" ]; then
1262                 warn "$_me: you must specify a ruleset"
1263                 return 1
1264         fi
1265         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1266         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1267                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1268                 return 1
1269         fi
1270         return 0
1271 }
1272
1273 # devfs_domount dir [ruleset]
1274 #       Mount devfs on dir. If ruleset is specified it is set
1275 #       on the mount-point. It must also be a ruleset name as specified
1276 #       in a devfs.rules(5) file. Returns 0 on success.
1277 #
1278 devfs_domount()
1279 {
1280         local devdir rs _me
1281         devdir="$1"
1282         [ -n "$2" ] && rs=$2 || rs=
1283         _me="devfs_domount()"
1284
1285         if [ -z "$devdir" ]; then
1286                 warn "$_me: you must specify a mount-point"
1287                 return 1
1288         fi
1289         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1290         if ! mount -t devfs dev "$devdir"; then
1291                 warn "$_me: Unable to mount devfs on $devdir"
1292                 return 1
1293         fi
1294         if [ -n "$rs" ]; then
1295                 devfs_init_rulesets
1296                 devfs_set_ruleset $rs $devdir
1297                 devfs -m $devdir rule applyset
1298         fi
1299         return 0
1300 }
1301
1302 # devfs_mount_jail dir [ruleset]
1303 #       Mounts a devfs file system appropriate for jails
1304 #       on the directory dir. If ruleset is specified, the ruleset
1305 #       it names will be used instead.  If present, ruleset must
1306 #       be the name of a ruleset as defined in a devfs.rules(5) file.
1307 #       This function returns non-zero if an error occurs.
1308 #
1309 devfs_mount_jail()
1310 {
1311         local jdev rs _me
1312         jdev="$1"
1313         [ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1314         _me="devfs_mount_jail"
1315
1316         devfs_init_rulesets
1317         if ! devfs_domount "$jdev" $rs; then
1318                 warn "$_me: devfs was not mounted on $jdev"
1319                 return 1
1320         fi
1321         return 0
1322 }
1323
1324 # Provide a function for normalizing the mounting of memory
1325 # filesystems.  This should allow the rest of the code here to remain
1326 # as close as possible between 5-current and 4-stable.
1327 #   $1 = size
1328 #   $2 = mount point
1329 #   $3 = (optional) extra mdmfs flags
1330 mount_md()
1331 {
1332         if [ -n "$3" ]; then
1333                 flags="$3"
1334         fi
1335         /sbin/mdmfs $flags -s $1 md $2
1336 }
1337
1338 # Code common to scripts that need to load a kernel module
1339 # if it isn't in the kernel yet. Syntax:
1340 #   load_kld [-e regex] [-m module] file
1341 # where -e or -m chooses the way to check if the module
1342 # is already loaded:
1343 #   regex is egrep'd in the output from `kldstat -v',
1344 #   module is passed to `kldstat -m'.
1345 # The default way is as though `-m file' were specified.
1346 load_kld()
1347 {
1348         local _loaded _mod _opt _re
1349
1350         while getopts "e:m:" _opt; do
1351                 case "$_opt" in
1352                 e) _re="$OPTARG" ;;
1353                 m) _mod="$OPTARG" ;;
1354                 *) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1355                 esac
1356         done
1357         shift $(($OPTIND - 1))
1358         if [ $# -ne 1 ]; then
1359                 err 3 'USAGE: load_kld [-e regex] [-m module] file'
1360         fi
1361         _mod=${_mod:-$1}
1362         _loaded=false
1363         if [ -n "$_re" ]; then
1364                 if kldstat -v | egrep -q -e "$_re"; then
1365                         _loaded=true
1366                 fi
1367         else
1368                 if kldstat -q -m "$_mod"; then
1369                         _loaded=true
1370                 fi
1371         fi
1372         if ! $_loaded; then
1373                 if ! kldload "$1"; then
1374                         warn "Unable to load kernel module $1"
1375                         return 1
1376                 else
1377                         info "$1 kernel module loaded."
1378                 fi
1379         else
1380                 debug "load_kld: $1 kernel module already loaded."
1381         fi
1382         return 0
1383 }
1384
1385 # ltr str src dst
1386 #       Change every $src in $str to $dst.
1387 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1388 #       awk(1).
1389 ltr()
1390 {
1391         local _str _src _dst _out _com
1392         _str=$1
1393         _src=$2
1394         _dst=$3
1395         _out=""
1396
1397         IFS=${_src}
1398         for _com in ${_str}; do
1399                 if [ -z "${_out}" ]; then
1400                         _out="${_com}"
1401                 else
1402                         _out="${_out}${_dst}${_com}"
1403                 fi
1404         done
1405         echo "${_out}"
1406 }
1407
1408 # Creates a list of providers for GELI encryption.
1409 geli_make_list()
1410 {
1411         local devices devices2
1412         local provider mountpoint type options rest
1413
1414         # Create list of GELI providers from fstab.
1415         while read provider mountpoint type options rest ; do
1416                 case ":${options}" in
1417                 :*noauto*)
1418                         noauto=yes
1419                         ;;
1420                 *)
1421                         noauto=no
1422                         ;;
1423                 esac
1424
1425                 case ":${provider}" in
1426                 :#*)
1427                         continue
1428                         ;;
1429                 *.eli)
1430                         # Skip swap devices.
1431                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1432                                 continue
1433                         fi
1434                         devices="${devices} ${provider}"
1435                         ;;
1436                 esac
1437         done < /etc/fstab
1438
1439         # Append providers from geli_devices.
1440         devices="${devices} ${geli_devices}"
1441
1442         for provider in ${devices}; do
1443                 provider=${provider%.eli}
1444                 provider=${provider#/dev/}
1445                 devices2="${devices2} ${provider}"
1446         done
1447
1448         echo ${devices2}
1449 }
1450
1451 # Find scripts in local_startup directories that use the old syntax
1452 #
1453 find_local_scripts_old () {
1454         zlist=''
1455         slist=''
1456         for dir in ${local_startup}; do
1457                 if [ -d "${dir}" ]; then
1458                         for file in ${dir}/[0-9]*.sh; do
1459                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1460                                     continue
1461                                 zlist="$zlist $file"
1462                         done
1463                         for file in ${dir}/[^0-9]*.sh; do
1464                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1465                                     continue
1466                                 slist="$slist $file"
1467                         done
1468                 fi
1469         done
1470 }
1471
1472 find_local_scripts_new () {
1473         local_rc=''
1474         for dir in ${local_startup}; do
1475                 if [ -d "${dir}" ]; then
1476                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1477                                 case "$file" in
1478                                 *.sample) ;;
1479                                 *)      if [ -x "$file" ]; then
1480                                                 local_rc="${local_rc} ${file}"
1481                                         fi
1482                                         ;;
1483                                 esac
1484                         done
1485                 fi
1486         done
1487 }
1488
1489 fi
1490
1491 _rc_subr_loaded=: